Index: tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/ChartsEngine.java
===================================================================
--- tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/ChartsEngine.java	(revision 312)
+++ tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/ChartsEngine.java	(revision 313)
@@ -13,6 +13,7 @@
 import org.txm.chartsengine.core.messages.ChartsEngineCoreMessages;
 import org.txm.chartsengine.core.preferences.ChartsEnginePreferences;
 import org.txm.chartsengine.core.results.IChartResult;
+import org.txm.core.preferences.TBXPreferences;
 import org.txm.core.preferences.TXMPreferences;
 import org.txm.utils.logger.Log;
 
@@ -345,7 +346,7 @@
 	public File createTmpFile(String prefix)	{
 		File file = null;
 		try {
-			File resultsDir = new File(Toolbox.getParam(Toolbox.USER_TXM_HOME), "results"); //$NON-NLS-1$
+			File resultsDir = new File(Toolbox.getParam(TBXPreferences.USER_TXM_HOME), "results"); //$NON-NLS-1$
 			resultsDir.mkdirs();
 			
 			// right padding to 3 characters long
Index: tmp/org.txm.ca.core/src/org/txm/ca/core/statsengine/r/functions/CA.java
===================================================================
--- tmp/org.txm.ca.core/src/org/txm/ca/core/statsengine/r/functions/CA.java	(revision 312)
+++ tmp/org.txm.ca.core/src/org/txm/ca/core/statsengine/r/functions/CA.java	(revision 313)
@@ -31,12 +31,11 @@
 
 import org.rosuda.REngine.REXP;
 import org.txm.ca.core.messages.CACoreMessages;
-import org.txm.lexicaltable.core.statsengine.data.LexicalTable;
+import org.txm.lexicaltable.core.statsengine.data.ILexicalTable;
 import org.txm.statsengine.core.StatException;
 import org.txm.statsengine.r.core.RWorkspace;
 import org.txm.statsengine.r.core.data.QuantitativeDataStructureImpl;
 import org.txm.statsengine.r.core.exceptions.RWorkspaceException;
-import org.txm.utils.messages.Utf8NLS;
 
 /**
  * Access to the R implementation of the Correspondance Analysis.
@@ -96,7 +95,7 @@
 	/**
 	 * The lexical table.
 	 */
-	private LexicalTable table;
+	private ILexicalTable table;
 	
 	/**
 	 * Create a correspondance analysis on the given table. The correspondance
@@ -105,10 +104,8 @@
 	 * @param table the table
 	 * @throws StatException the stat exception
 	 */
-	public CA(LexicalTable table) throws StatException {
-
+	public CA(ILexicalTable table) throws StatException {
 		
-		
 		if (!rw.containsVariable(table.getSymbol())) {
 			throw new StatException(CACoreMessages.ERROR_0);
 		}
Index: tmp/org.txm.ca.core/src/org/txm/ca/core/statsengine/r/functions/FactoMineRCA.java
===================================================================
--- tmp/org.txm.ca.core/src/org/txm/ca/core/statsengine/r/functions/FactoMineRCA.java	(revision 312)
+++ tmp/org.txm.ca.core/src/org/txm/ca/core/statsengine/r/functions/FactoMineRCA.java	(revision 313)
@@ -33,7 +33,7 @@
 import org.rosuda.REngine.REXP;
 import org.rosuda.REngine.REXPMismatchException;
 import org.txm.ca.core.messages.CACoreMessages;
-import org.txm.lexicaltable.core.statsengine.data.LexicalTable;
+import org.txm.lexicaltable.core.statsengine.data.ILexicalTable;
 import org.txm.statsengine.core.StatException;
 import org.txm.statsengine.r.core.RWorkspace;
 import org.txm.statsengine.r.core.data.QuantitativeDataStructureImpl;
@@ -95,7 +95,7 @@
 	/** The colscoords. */
 	private double[][] colscoords;
 
-	private LexicalTable table;	
+	private ILexicalTable table;	
 	
 	/**
 	 * Create a correspondence analysis on the given table. The correspondence analysis is computed as soon as the object is created.
@@ -103,7 +103,7 @@
 	 * @param table the table
 	 * @throws StatException the stat exception
 	 */
-	public FactoMineRCA(LexicalTable table) throws StatException {
+	public FactoMineRCA(ILexicalTable table) throws StatException {
 
 		if (!rw.containsVariable(table.getSymbol())) {
 			throw new StatException(CACoreMessages.ERROR_0);
Index: tmp/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/preferences/RPreferences.java
===================================================================
--- tmp/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/preferences/RPreferences.java	(revision 312)
+++ tmp/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/preferences/RPreferences.java	(revision 313)
@@ -2,7 +2,6 @@
 
 
 import org.eclipse.core.runtime.preferences.DefaultScope;
-import org.osgi.framework.FrameworkUtil;
 import org.osgi.service.prefs.Preferences;
 import org.txm.core.preferences.TXMPreferences;
 
@@ -17,7 +16,7 @@
 
 
 	// auto populate the preference node qualifier from the current bundle id
-	public static final String PREFERENCES_NODE = FrameworkUtil.getBundle(RPreferences.class).getSymbolicName();
+	public static final String PREFERENCES_NODE = RPreferences.class.getName();//FrameworkUtil.getBundle(RPreferences.class).getSymbolicName();
 	
 	//FIXME: tests
 	//public static final String PREFERENCES_NODE = "org.txm.statsengine.r.core";
@@ -60,9 +59,6 @@
 	public static final String FILE_TRANSFERT = PREFERENCES_PREFIX + "file_transfert"; //$NON-NLS-1$
 	public static final String SVG_DEVICE = PREFERENCES_PREFIX + "svg_device"; //$NON-NLS-1$
 
-
-	
-
 	/**
 	 * 
 	 */
Index: tmp/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/data/QuantitativeDataStructureImpl.java
===================================================================
--- tmp/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/data/QuantitativeDataStructureImpl.java	(revision 312)
+++ tmp/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/data/QuantitativeDataStructureImpl.java	(revision 313)
@@ -42,7 +42,7 @@
  * 
  * @author Sylvain Loiseau &lt;sloiseau@ens-lsh.fr&gt;
  */
-public abstract class QuantitativeDataStructureImpl extends TXMResult implements QuantitativeDataStructure {
+public abstract class QuantitativeDataStructureImpl implements QuantitativeDataStructure {
 	
 	/** The counter. */
 	private static int counter = 1;
Index: tmp/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/data/ContingencyTableImpl.java
===================================================================
--- tmp/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/data/ContingencyTableImpl.java	(revision 312)
+++ tmp/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/data/ContingencyTableImpl.java	(revision 313)
@@ -42,7 +42,7 @@
  * 
  * @author sloiseau
  */
-public class ContingencyTableImpl extends MatrixImpl implements ContingencyTable {
+public abstract class ContingencyTableImpl extends MatrixImpl implements ContingencyTable {
 
 	/**
 	 * Create a new contingency table after a {@link DoubleMatrix2D}.
Index: tmp/org.txm.lexicaltable.core/src/org/txm/functions/intertextualdistance/InterTextDistance.java
===================================================================
--- tmp/org.txm.lexicaltable.core/src/org/txm/functions/intertextualdistance/InterTextDistance.java	(revision 312)
+++ tmp/org.txm.lexicaltable.core/src/org/txm/functions/intertextualdistance/InterTextDistance.java	(revision 313)
@@ -8,7 +8,7 @@
 import org.rosuda.REngine.REXP;
 import org.rosuda.REngine.REXPMismatchException;
 import org.txm.functions.Function;
-import org.txm.lexicaltable.core.statsengine.data.LexicalTable;
+import org.txm.lexicaltable.core.statsengine.data.ILexicalTable;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.clientExceptions.InvalidCqpIdException;
 import org.txm.statsengine.core.StatException;
@@ -16,10 +16,10 @@
 
 public class InterTextDistance extends Function {
 	
-	LexicalTable table;
+	ILexicalTable table;
 	String method = "euclidian"; //$NON-NLS-1$
 	
-	public InterTextDistance(LexicalTable table) {
+	public InterTextDistance(ILexicalTable table) {
 		this.table = table;
 	}
 	public boolean compute() throws CqiClientException, InvalidCqpIdException, REXPMismatchException, StatException {
@@ -48,7 +48,7 @@
 		return true;
 	}
 	
-	public LexicalTable getTable() {
+	public ILexicalTable getTable() {
 		return table;
 	}
 	
Index: tmp/org.txm.lexicaltable.core/src/org/txm/lexicaltable/core/statsengine/data/ILexicalTable.java
===================================================================
--- tmp/org.txm.lexicaltable.core/src/org/txm/lexicaltable/core/statsengine/data/ILexicalTable.java	(revision 0)
+++ tmp/org.txm.lexicaltable.core/src/org/txm/lexicaltable/core/statsengine/data/ILexicalTable.java	(revision 313)
@@ -0,0 +1,237 @@
+// Copyright © 2010-2013 ENS de Lyon.
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+// 
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+// 
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+// 
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+// 
+// 
+// 
+// $LastChangedDate: 2016-09-19 10:31:00 +0200 (Mon, 19 Sep 2016) $
+// $LastChangedRevision: 3298 $
+// $LastChangedBy: mdecorde $ 
+//
+package org.txm.lexicaltable.core.statsengine.data;
+
+import java.io.File;
+import java.util.List;
+
+import org.rosuda.REngine.REXPMismatchException;
+import org.txm.core.results.ITXMResult;
+import org.txm.searchengine.cqp.corpus.Corpus;
+import org.txm.searchengine.cqp.corpus.Partition;
+import org.txm.searchengine.cqp.corpus.Property;
+import org.txm.statsengine.core.StatException;
+import org.txm.statsengine.core.data.ContingencyTable;
+import org.txm.statsengine.core.data.Vector;
+import org.txm.statsengine.r.core.exceptions.RWorkspaceException;
+
+// TODO: Auto-generated Javadoc
+/**
+ * A LexicalTable is a special kind of {@link ContingencyTable} extracted from a
+ * corpora given a {@link Partition} (the columns) and a {@link Property} (the
+ * rows).
+ * 
+ * Can be edited, rows can be deleted cols can be deleted
+ * 
+ * can be exported of imported from/to a file
+ * 
+ * @author sloiseau
+ */
+public interface ILexicalTable extends ContingencyTable {
+
+	/**
+	 * Insert a column representing the reference corpus
+	 * @param symbol
+	 */
+	public abstract void setReference(String symbol);
+	
+	/**
+	 * Gets the copy.
+	 *
+	 * @return the copy
+	 */
+	public abstract ILexicalTable getCopy();
+
+	/**
+	 * Sort.
+	 *
+	 * @param colindex the colindex
+	 * @param reverse the reverse
+	 */
+	public abstract void sort(int colindex, Boolean reverse);
+
+	/**
+	 * Sort row names.
+	 *
+	 * @param reverse the reverse
+	 */
+	public void sortRowNames(Boolean reverse);
+
+	/**
+	 * Removes the col.
+	 *
+	 * @param col the col
+	 * @param checkEmptyLines the check empty lines
+	 */
+	public abstract void removeCol(int col, boolean checkEmptyLines);
+
+	/**
+	 * Removes the cols.
+	 *
+	 * @param cols the cols
+	 */
+	public abstract void removeCols(List<Integer> cols);
+
+	/**
+	 * Removes the cols.
+	 *
+	 * @param coltodelete the coltodelete
+	 */
+	public abstract void removeCols(int[] coltodelete);
+
+	/**
+	 * Removes the row.
+	 *
+	 * @param row the row
+	 */
+	public abstract void removeRow(int row);
+
+	/**
+	 * Removes the rows.
+	 *
+	 * @param row the row
+	 */
+	public abstract void removeRows(List<Integer> row);
+
+	/**
+	 * Removes the rows.
+	 *
+	 * @param selectionIndices the selection indices
+	 */
+	public abstract void removeRows(int[] selectionIndices);
+
+	/**
+	 * Sets the.
+	 *
+	 * @param row the row
+	 * @param col the col
+	 * @param value the value
+	 */
+	public abstract void set(int row, int col, double value);
+
+	/**
+	 * Gets the fmin.
+	 *
+	 * @return the fmin
+	 */
+	public abstract int getFmin();
+	
+	/**
+	 * Gets the fmax.
+	 *
+	 * @return the fmax
+	 */
+	public abstract int getFmax();
+
+	/**
+	 * Removes the rows.
+	 *
+	 * @param i the i
+	 * @param j the j
+	 */
+	public abstract void removeRows(int i, int j);
+
+	/**
+	 * Cut.
+	 * TODO: must be done after calling copy(), check why.
+	 *
+	 * @param nlines the number of lines to keep
+	 */
+	public abstract void cut(int nlines);
+
+	/**
+	 * Filter.
+	 *
+	 * @param freqs the freqs
+	 * @param nlines the nlines
+	 * @param fmin the fmin
+	 */
+	public abstract void filter(int nlines, int fmin) throws Exception;
+
+	/**
+	 * Sets the order.
+	 *
+	 * @param neworder the neworder
+	 * @param reverse the reverse
+	 */
+	abstract public void setOrder(List<Integer> neworder, Boolean reverse);
+
+	/**
+	 * Gets the freqs.
+	 *
+	 * @return the freqs
+	 */
+	public abstract List<Integer> getFreqs();
+
+	/**
+	 * Export data.
+	 *
+	 * @param file the file
+	 * @param colseparator the colseparator
+	 * @param txtseparator the txtseparator
+	 */
+	public abstract void exportData(File file, String colseparator, String txtseparator);
+	public abstract void toTxt(File outfile, String encoding, String colseparator, String txtseparator);
+	
+	/**
+	 * Import data.
+	 *
+	 * @param file the file
+	 */
+	public abstract boolean importData(File file) throws RWorkspaceException, REXPMismatchException;
+
+	public abstract void sortByFreqs(boolean reverse) throws Exception;
+
+	@Override
+	public abstract Vector getRowMarginsVector() throws StatException;
+	
+	@Override
+	public abstract Vector getColMarginsVector() throws StatException;
+	
+	@Override
+	public abstract int[] getRowMargins() throws Exception;
+	
+	@Override
+	public abstract int[] getColMargins() throws Exception;
+	
+	
+	/**
+	 * Gets the number of rows.
+	 * @return the number of rows
+	 */
+	public abstract int getRowsCount();
+
+	
+	/**
+	 * Gets the number of columns.
+	 * @return the number of columns
+	 */
+	public abstract int getColumnsCount();
+
+
+}

Index: tmp/org.txm.lexicaltable.core/src/org/txm/lexicaltable/core/functions/LexicalTable.java
===================================================================
--- tmp/org.txm.lexicaltable.core/src/org/txm/lexicaltable/core/functions/LexicalTable.java	(revision 0)
+++ tmp/org.txm.lexicaltable.core/src/org/txm/lexicaltable/core/functions/LexicalTable.java	(revision 313)
@@ -0,0 +1,143 @@
+package org.txm.lexicaltable.core.functions;
+
+import org.txm.core.results.TXMResult;
+import org.txm.lexicaltable.core.statsengine.data.ILexicalTable;
+import org.txm.lexicaltable.core.statsengine.r.data.LexicalTableImpl;
+import org.txm.lexicon.core.corpusengine.cqp.Lexicon;
+import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
+import org.txm.searchengine.cqp.corpus.Corpus;
+import org.txm.searchengine.cqp.corpus.Partition;
+import org.txm.searchengine.cqp.corpus.Property;
+import org.txm.searchengine.cqp.corpus.Subcorpus;
+import org.txm.statsengine.core.StatException;
+import org.txm.statsengine.core.data.Vector;
+import org.txm.statsengine.r.core.RWorkspace;
+import org.txm.statsengine.r.core.exceptions.RWorkspaceException;
+
+/**
+ * ILexicalTable logic + TXMResult management methods
+ * 
+ * @author mdecorde
+ *
+ */
+public class LexicalTable extends TXMResult {
+	
+	/** the statengine data object */
+	ILexicalTable data;
+	
+	/** The partition. */
+	private Partition partition;
+
+	/** The corpus. */
+	private Corpus corpus;
+
+	/** The property. */
+	private Property property;
+
+	/** The constructor_fmin. */
+	private int constructor_fmin;
+	
+	/**
+	 * Get the partition this lexical table is bound to.
+	 * 
+	 * @return the partition
+	 */
+	public Partition getPartition() {
+		return partition;
+	}
+	
+	/**
+	 * Get the corpus this lexical table is bound to.
+	 * 
+	 * @return the corpus or null if the LexicalTable was build without a Corpus or thiout a Partition (built with a Corpus)
+	 */
+	public Corpus getCorpus() {
+		if (corpus != null) return corpus;
+		else if (partition != null) return partition.getCorpus();
+		else return null;
+	}
+
+	/**
+	 * Get the property this lexical table is bound to.
+	 * 
+	 * @return the property.
+	 */
+	public Property getProperty() {
+		return property;
+	}
+
+	@Override
+	public String getName() {
+		return data.getSymbol();
+	}
+
+	@Override
+	public String getSimpleName() {
+		return data.getSymbol();
+	}
+
+	@Override
+	public String getDetails() {
+		return data.getSymbol();
+	}
+
+	@Override
+	public void clean() {
+		try {
+			RWorkspace.getRWorkspaceInstance().removeVariableFromWorkspace(data.getSymbol());
+		} catch (RWorkspaceException e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+	}
+	
+	
+	
+	public LexicalTable(Lexicon corpusLexicon, Lexicon subcorpusLexicon) throws StatException {
+		super();
+		
+		data = new LexicalTableImpl(corpusLexicon.getName()+ "minus" + subcorpusLexicon.getName(), corpusLexicon, subcorpusLexicon);
+		
+		this.property = corpusLexicon.getProperty();
+		this.corpus = corpusLexicon.getCorpus();
+		this.corpus.addResult(this);
+	}
+	
+	public LexicalTable(Corpus corpus, Subcorpus subcorpus) throws StatException, CqiClientException {
+		this(Lexicon.getLexicon(corpus, corpus.getProperty("word")), Lexicon.getLexicon(subcorpus, subcorpus.getProperty("word")));
+	}
+	
+	public LexicalTable(Corpus corpus, Subcorpus subcorpus, Property property) throws StatException, CqiClientException {
+		this(Lexicon.getLexicon(corpus, property), Lexicon.getLexicon(subcorpus, property));
+	}
+
+	public LexicalTable(Partition partition, Property analysisProperty, int fmin, LexicalTableImpl itable) {
+		this.property = partition.getProperty();
+		this.partition = partition;
+		this.corpus = partition.getCorpus();
+	}
+
+	public ILexicalTable getData() {
+		return data;
+	}
+
+	public Vector getRowNames() {
+		return data.getRowNames();
+	}
+	
+	public Vector getColNames() {
+		return data.getRowNames();
+	}
+
+	public int getNColumns() {
+		return data.getNColumns();
+	}
+
+	public Vector getColMarginsVector() throws StatException {
+		return data.getColMarginsVector();
+	}
+
+	public Vector getRowMarginsVector() throws StatException {
+		return data.getRowMarginsVector();
+	}
+}

Index: tmp/org.txm.lexicaltable.core/src/org/txm/lexicaltable/core/functions/LexicalTableFactory.java
===================================================================
--- tmp/org.txm.lexicaltable.core/src/org/txm/lexicaltable/core/functions/LexicalTableFactory.java	(revision 312)
+++ tmp/org.txm.lexicaltable.core/src/org/txm/lexicaltable/core/functions/LexicalTableFactory.java	(revision 313)
@@ -1,37 +1,92 @@
 package org.txm.lexicaltable.core.functions;
 
-import org.txm.lexicaltable.core.statsengine.data.LexicalTable;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.txm.core.results.ITXMResult;
+import org.txm.lexicaltable.core.statsengine.data.ILexicalTable;
 import org.txm.lexicaltable.core.statsengine.r.data.LexicalTableImpl;
+import org.txm.lexicon.core.corpusengine.cqp.Lexicon;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
+import org.txm.searchengine.cqp.corpus.Corpus;
 import org.txm.searchengine.cqp.corpus.Partition;
 import org.txm.searchengine.cqp.corpus.Property;
 import org.txm.statsengine.core.StatException;
+import org.txm.statsengine.r.core.exceptions.RWorkspaceException;
 
 public class LexicalTableFactory {
+
 	/**
-	 * Create a lexical table for this partition given an analysis property.
-	 * Lexical table are cached and recycled. In order to drop from memory a
-	 * lexical table, use {@link #dropLexicalTable(Property)}.
+	 * Create a Complete Lexical Table according to a Partition and a Property.
 	 *
+	 * @param partition the partition
 	 * @param analysisProperty the analysis property
 	 * @param Fmin the fmin
 	 * @return the lexical table
-	 * @throws StatException the stat exception
 	 * @throws CqiClientException the cqi client exception
-	 * @author sloiseau
+	 * @throws RWorkspaceException the r workspace exception
 	 */
-	public static LexicalTable getLexicalTable(Partition partition, Property analysisProperty, int Fmin)
-	throws StatException, CqiClientException {
-		// System.out.println("CL : test si déja existant ds cache");
-		/*if (lexicalTables.containsKey(analysisProperty.getName())) {
-			if (lexicalTables.get(analysisProperty.getName()).getConstructorFmin() == Fmin)
-				return lexicalTables.get(analysisProperty.getName());
-		}*/
-		// System.out.println("CL : fait un new lexique");
-		LexicalTable t = LexicalTableImpl.getLexicalTable(partition, analysisProperty, Fmin);
+	public static final LexicalTable getLexicalTable(Partition partition,
+			Property analysisProperty, int Fmin) throws CqiClientException,
+			RWorkspaceException {
+		//long time = System.currentTimeMillis();
+		List<Lexicon> lexicons = new ArrayList<Lexicon>();
+		// Set<String> allLexiconEntry = new HashSet<String>();
+		for (int i = 0; i < partition.getNPart(); i++) {
+			Lexicon l = Lexicon.getLexicon(partition.getParts().get(i), analysisProperty);
+			lexicons.add(l);
+		}
+		//System.out.println("time lexicon build "+(System.currentTimeMillis()-time));
+		//time = System.currentTimeMillis();
+		// String[] entries = allLexiconEntry.toArray(new String[]{});
+		Corpus c = partition.getCorpus();
+		Lexicon ll = Lexicon.getLexicon(c, analysisProperty);
 
-		// System.out.println("CL : put results ds le cache");
-		//partition.storeResult(t);
-		return t;
+		ArrayList<String> filteredForms = new ArrayList<String>();
+		//create a copy and filter line with Fmin;
+		for (int i = 0 ; i < ll.getFreq().length ; i++) {
+			if (ll.getFreq()[i] >= Fmin) {
+				filteredForms.add(ll.getForms()[i]);
+			}
+		}
+		//System.out.println("remove freq too low "+(System.currentTimeMillis()-time));
+		//time = System.currentTimeMillis();
+		Map<String, Integer> entries2index = new HashMap<String, Integer>();
+		for (int i = 0; i < filteredForms.size(); i++) {
+			entries2index.put(filteredForms.get(i), i);
+		}
+
+		//System.out.println("entries2index "+(System.currentTimeMillis()-time));
+		//time = System.currentTimeMillis();
+		int[][] mat = new int[filteredForms.size()][lexicons.size()];//DoubleFactory2D.sparse.make(filteredForms.size(), lexicons.size(), 0);
+
+
+		Integer id= null;
+		for (int i = 0; i < lexicons.size(); i++) {
+			Lexicon l = lexicons.get(i);
+			String[] ents = l.getForms();
+			int[] freqs = l.getFreq();
+			for (int j = 0; j < freqs.length; j++) {
+				id = entries2index.get(ents[j]);
+				// if (entriesFreqs[id] >= 2)
+				if (id != null)
+					mat[id][i] = freqs[j]; //mat.setQuick(id, i, freqs[j]);
+			}
+		}
+		//System.out.println("time build matrix "+(System.currentTimeMillis()-time));
+		//time = System.currentTimeMillis();
+		//System.out.println("Entries size " + filteredForms.size());
+		//System.out.println("mat size " + mat.rows());
+		//System.out.println("mat columns " + mat.columns());
+
+		LexicalTableImpl itable = new LexicalTableImpl(mat, filteredForms.toArray(new String[]{}), partition.getPartShortNames()
+				.toArray(new String[] {}));
+		
+		LexicalTable table = new LexicalTable(partition,
+				analysisProperty, Fmin, itable);
+		//System.out.println("time build table lexical "+(System.currentTimeMillis()-time));
+		return table;
 	}
 }
Index: tmp/org.txm.lexicaltable.core/src/org/txm/lexicon/core/messages/LexiconCoreMessages.java
===================================================================
--- tmp/org.txm.lexicaltable.core/src/org/txm/lexicon/core/messages/LexiconCoreMessages.java	(revision 0)
+++ tmp/org.txm.lexicaltable.core/src/org/txm/lexicon/core/messages/LexiconCoreMessages.java	(revision 313)
@@ -0,0 +1,32 @@
+package org.txm.lexicon.core.messages;
+
+import org.eclipse.osgi.util.NLS;
+import org.txm.utils.messages.Utf8NLS;
+
+
+/**
+ * Lexicon core messages.
+ * 
+ * @author mdecorde
+ * @author sjacquot
+ *
+ */
+public class LexiconCoreMessages extends NLS {
+
+	private static final String BUNDLE_NAME = "org.txm.lexicon.core.messages.messages"; //$NON-NLS-1$
+
+	public static String RESULT_TYPE;
+	public static String Lexicon_0;
+	public static String Lexicon_3;
+	public static String DetailsFromPartition;
+	public static String DetailsFromCorpus;
+
+	
+	static {
+		// initialize resource bundle
+		Utf8NLS.initializeMessages(BUNDLE_NAME, LexiconCoreMessages.class);
+	}
+
+	private LexiconCoreMessages() {
+	}
+}

Index: tmp/org.txm.wordcloud.core/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.wordcloud.core/META-INF/MANIFEST.MF	(revision 312)
+++ tmp/org.txm.wordcloud.core/META-INF/MANIFEST.MF	(revision 313)
@@ -9,7 +9,8 @@
  org.txm.core;bundle-version="0.7.0",
  org.txm.chartsengine.jfreechart.core;bundle-version="1.0.0",
  org.txm.chartsengine.r.core;bundle-version="1.0.0",
- org.txm.index.core;bundle-version="1.0.0"
+ org.txm.index.core;bundle-version="1.0.0",
+ org.txm.lexicon.core
 Export-Package: org.txm.wordcloud.core.chartsengine.jfreechart,
  org.txm.wordcloud.core.chartsengine.r,
  org.txm.wordcloud.core.functions,
Index: tmp/org.txm.index.core/src/org/txm/index/core/functions/Index.java
===================================================================
--- tmp/org.txm.index.core/src/org/txm/index/core/functions/Index.java	(revision 312)
+++ tmp/org.txm.index.core/src/org/txm/index/core/functions/Index.java	(revision 313)
@@ -226,7 +226,7 @@
 			this.props = new ArrayList<Property>();
 			this.props.add(property);
 
-			lexicon = corpus.getLexicon(property);
+			lexicon = Lexicon.getLexicon(corpus, property);
 
 			lexicon.addResult(this);
 			
Index: tmp/org.txm.utils/src/org/txm/utils/io/IOUtils.java
===================================================================
--- tmp/org.txm.utils/src/org/txm/utils/io/IOUtils.java	(revision 312)
+++ tmp/org.txm.utils/src/org/txm/utils/io/IOUtils.java	(revision 313)
@@ -11,6 +11,7 @@
 import java.io.OutputStreamWriter;
 import java.io.PrintWriter;
 import java.io.UnsupportedEncodingException;
+import java.util.ArrayList;
 
 import org.txm.utils.i18n.DetectBOM;
 
@@ -60,11 +61,11 @@
 	public static PrintWriter getWriter(File file, String encoding) throws UnsupportedEncodingException, FileNotFoundException {
 		return getWriter(file, encoding, false);
 	}
-	
+
 	public static PrintWriter getWriter(File file, boolean append) throws UnsupportedEncodingException, FileNotFoundException {
 		return getWriter(file, "UTF-8", append);
 	}
-	
+
 	public static PrintWriter getWriter(File file, String encoding, boolean append) throws UnsupportedEncodingException, FileNotFoundException {
 		return new PrintWriter(new OutputStreamWriter(new BufferedOutputStream(new FileOutputStream(file, append)) , "UTF-8")); //$NON-NLS-1$
 	}
@@ -77,6 +78,21 @@
 		PrintWriter writer = getWriter(file);
 		writer.write(str);
 		writer.close();
-		
+
 	}
+
+	public static ArrayList<String> getLines(File file, String encoding) {
+		ArrayList<String> lines = new ArrayList<String>();
+		try {
+			BufferedReader reader = IOUtils.getReader(file, encoding);
+			String line = reader.readLine();
+			while (line != null) {
+				lines.add(line);
+				line = reader.readLine();
+			}
+		} catch(Exception e) {
+			System.out.println("Error while getting lines: "+e.getLocalizedMessage());
+		}
+		return lines;
+	}
 }
Index: tmp/org.txm.cooccurrence.core/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.cooccurrence.core/META-INF/MANIFEST.MF	(revision 312)
+++ tmp/org.txm.cooccurrence.core/META-INF/MANIFEST.MF	(revision 313)
@@ -3,8 +3,9 @@
 Bundle-Name: Cooccurrence Core
 Bundle-SymbolicName: org.txm.cooccurrence.core;singleton:=true
 Bundle-Version: 1.0.0.qualifier
-Require-Bundle: org.txm.lexicaltable.core,
+Require-Bundle: org.txm.concordance.core;bundle-version="1.0.0",
  org.txm.core;bundle-version="0.7.0";visibility:=reexport,
+ org.txm.lexicaltable.core,
  org.txm.specificities.core;bundle-version="1.0.0",
  org.eclipse.core.runtime,
  org.txm.index.core;bundle-version="1.0.0"
Index: tmp/org.txm.cooccurrence.core/src/org/txm/cooccurrence/core/functions/Cooccurrence.java
===================================================================
--- tmp/org.txm.cooccurrence.core/src/org/txm/cooccurrence/core/functions/Cooccurrence.java	(revision 312)
+++ tmp/org.txm.cooccurrence.core/src/org/txm/cooccurrence/core/functions/Cooccurrence.java	(revision 313)
@@ -48,7 +48,8 @@
 import org.txm.functions.concordances.Concordance;
 import org.txm.functions.concordances.Line;
 import org.txm.index.core.functions.Index;
-import org.txm.lexicaltable.core.statsengine.data.LexicalTable;
+import org.txm.lexicaltable.core.functions.LexicalTable;
+import org.txm.lexicaltable.core.functions.LexicalTableFactory;
 import org.txm.lexicaltable.core.statsengine.r.data.LexicalTableImpl;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.clientExceptions.UnexpectedAnswerException;
@@ -60,8 +61,9 @@
 import org.txm.searchengine.cqp.corpus.query.Match;
 import org.txm.searchengine.cqp.corpus.query.Query;
 import org.txm.searchengine.cqp.serverException.CqiServerError;
-import org.txm.specificities.core.functions.Specificites;
 import org.txm.specificities.core.functions.SpecificitesResult;
+import org.txm.specificities.core.statsengine.r.function.SpecificitiesImpl;
+import org.txm.lexicaltable.core.statsengine.data.ILexicalTable;
 import org.txm.statsengine.core.StatException;
 import org.txm.statsengine.r.core.RWorkspace;
 import org.txm.statsengine.r.core.exceptions.RWorkspaceException;
@@ -198,7 +200,7 @@
 	private HashMap<Integer, String> allsignaturesstr;
 
 	/** The lt. */
-	private LexicalTable lt;
+	private LexicalTableImpl lt;
 
 	/** The keys to string. */
 	private HashMap<String, String> keysToString;
@@ -676,8 +678,8 @@
 		}
 		if (Thread.interrupted()) return false; // stop if interrupted by user
 
-		// ALTER THE INDEX IF A REFERENCE CORPUS IS SET
-		if(referenceCorpus != null && referenceCorpus.length() > 0) {
+		// ALTER THE INDEX IF A REFERENCE CORPUS IS SET -> this change the base frequencies
+		if (referenceCorpus != null && referenceCorpus.length() > 0) {
 			//voc.toTxt(new File("/home/mdecorde/TEMP/before.tsv"), "UTF-8", "\t", "");
 			try {
 				voc.setIsAltered(true);
@@ -774,8 +776,7 @@
 		//			//writer.println("Cols: "+Arrays.toString(colnames));
 		//		} catch(Exception e) {e.printStackTrace();}
 
-		lt = LexicalTableImpl.createLexicalTable(freqs, properties.get(0), rownames, colnames, 1);
-		lt.setCorpus(corpus);
+		lt = new LexicalTableImpl(freqs, rownames, colnames);
 
 		//		if(referenceCorpus != null && referenceCorpus.length() > 0) {
 		//			//lt.removeCol(0, false);
@@ -794,13 +795,13 @@
 	 */
 	public boolean stepGetScores() throws CqiClientException, StatException
 	{
-		SpecificitesResult specif = Specificites.specificites(lt, 1000);
+		SpecificitiesImpl specif = new SpecificitiesImpl(lt);
 		//System.out.println("Specif N part: "+specif.getNbrPart()); //$NON-NLS-1$
 		//System.out.println("Specif N lines number: "+specif.getSpecificitesIndex().length); //$NON-NLS-1$
 		//System.out.println("T specif e: "+(System.currentTimeMillis()- time)); //$NON-NLS-1$
 		//specif.toTxt(new File("~/Bureau/coocresults/specif Cooc")); //$NON-NLS-1$
-		String[] specifrownames = specif.getTypeNames();
-		double[][] scores = specif.getSpecificitesIndex();
+		String[] specifrownames = specif.getRowNames().asStringsArray();
+		double[][] scores = specif.getScores();
 		//System.out.println("Nb specif result: "+specif.getSpecificitesIndex().length);
 
 		int iimax = Math.min(specifrownames.length, scores.length);
